package com.jtxt.demo.controller;

import com.jtxt.demo.model.Event;
import com.jtxt.demo.model.User;
import com.jtxt.demo.service.EventService;
import com.jtxt.demo.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class EventController {
    @Autowired
    private UserService userService;
    @Autowired
    private EventService eventService;

    @PostMapping("/events/{userName}")
    public ResponseEntity<?> publishEvent(@PathVariable String userName, @RequestBody Event event) {
        User user = userService.findByUserName(userName);
        if(user == null){
            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
        }
        return new ResponseEntity<>(eventService.handleEvent(userName, event), HttpStatus.OK);
    }
}
