package com.jtxt.demo.controller;

import com.jtxt.demo.model.Group;
import com.jtxt.demo.model.LeaderBoard;
import com.jtxt.demo.service.LeaderBoardService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class LeaderBoardController {
    @Autowired
    private LeaderBoardService leaderBoardService;

    @GetMapping("/leaderboard")
    public ResponseEntity<?> getLeaderBoard(@RequestParam("type") LeaderBoard.LeaderBoardType type) {
        boolean foundType = false;
        for (LeaderBoard.LeaderBoardType existing_type : LeaderBoard.LeaderBoardType.values()) {
            if (existing_type == type) {
                foundType = true;
                break;
            }
        }
        if (!foundType) {
            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
        }
        return new ResponseEntity<>(leaderBoardService.getLatestLeaderBoardByType(type), HttpStatus.OK);
    }
    @GetMapping("/leaderboard/{name}")
    public ResponseEntity<?> getLeaderBoardByName(@PathVariable String name) {
        LeaderBoard board = leaderBoardService.findByName(name);
        if (board == null) {
            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
        }
        return new ResponseEntity<>(board, HttpStatus.OK);
    }
}
