package com.jtxt.demo.service;

import com.jtxt.demo.model.*;

import java.util.List;

public interface ExamService {
    Exam getExamByName(String name);
    Exam getExamById(String id);
    List<ExamHistory> showExamHistoriesForUser(String userName);
    List<Exam> showAllAvailableExams(User user);
    List<Exam> showAllExams();
    Exam createExam(Exam exam);
    Exam editExam(Exam updatedExam);
    boolean deleteExam(Exam exam);
    List<String> startExam(Exam exam, User user);
    List<String> randomlyPickQuestions(int number);
    ExamHistory endExam(ExamHistory examHistory);
    boolean addQuestionsToExam(Exam exam, List<ExamToQuestion> examToQuestions);
    boolean addQuestionToExam(Exam exam, Question question);
    boolean removeQuestionFromExam(Exam exam, Question question);
}
