package com.jtxt.demo.service;

import com.jtxt.demo.model.Comment;
import com.jtxt.demo.model.LearningMaterial;
import com.jtxt.demo.model.MaterialCategory;
import com.jtxt.demo.model.User;

import java.util.List;

public interface LearningMaterialService {
    LearningMaterial getMaterialByName(String name);
    LearningMaterial getMaterialById(String id);
    boolean deleteMaterial(LearningMaterial material);
    LearningMaterial editMaterial(LearningMaterial updatedMaterial);
    void likeMaterial(LearningMaterial material, User user, boolean isLike);
    void readMaterial(LearningMaterial material, User user);
    boolean isMaterialReadable(LearningMaterial material, String userName);
    boolean isMaterialLikeable(LearningMaterial material, String userName);
    void commentMaterial(Comment comment);
    List<Comment> showComments(LearningMaterial material);
    List<LearningMaterial> searchMaterialsByName(String name);
    LearningMaterial createMaterial(LearningMaterial material);

}
