package com.jtxt.demo.service;

import com.jtxt.demo.model.Event;
import com.jtxt.demo.model.PointsHistory;

import java.time.LocalDateTime;
import java.util.List;

public interface PointsHistoryService {
    /**
     * delta and description are optional. If delta is not null,
     * then it will overwrite default event delta.
     * @param userName
     * @param event what event does this change belongs to
     * @param delta [optional] If not null, we will use given value as point change.
     * @param description [optional]why we need this change
     * @return
     */
    boolean updateUserPoints(String userName, Event event, int delta, String description);
    int showPoints(String userName, LocalDateTime start, LocalDateTime end);
    List<PointsHistory> showPointsHistory(String userName);
}
