package com.jtxt.demo.service;

import com.jtxt.demo.model.Event;
import com.jtxt.demo.model.PointsHistory;
import com.jtxt.demo.repository.PointsHistoryRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.List;

import static com.jtxt.demo.util.Constants.CHINA_ZONE;

@Service
public class PointsHistoryServiceImpl implements PointsHistoryService {
    @Autowired
    private PointsHistoryRepository pointsHistoryRepository;
    @Override
    public boolean updateUserPoints(String userName, Event event, int delta, String description) {
        PointsHistory pointsHistory = new PointsHistory();
        pointsHistory.setEvent(event);
        pointsHistory.setDelta(delta);
        pointsHistory.setDescription(description);
        pointsHistory.setUserId(userName);
        pointsHistory.setCreatedTime(LocalDateTime.now(CHINA_ZONE));
        pointsHistoryRepository.insert(pointsHistory);
        return true;
    }

    @Override
    public int showPoints(String userName, LocalDateTime start, LocalDateTime end) {
        if (end == null) {
            // 为截止当前
            end = LocalDateTime.now(CHINA_ZONE);
        }
        List<PointsHistory> list = pointsHistoryRepository.findAllByUserIdAndCreatedTimeBetween(userName, start, end);
        return list.stream().map(pointsHistory -> pointsHistory.getDelta()).reduce(0, (a, b) -> a+b);
    }

    @Override
    public List<PointsHistory> showPointsHistory(String userName) {
        return pointsHistoryRepository.findAllByUserId(userName);
    }
}
