package com.jtxt.demo.service;

import com.jtxt.demo.model.*;

import java.util.List;

public interface UserService {
    boolean createUser(User user);
    boolean createUsers(List<User> users);
    boolean loginUser(User user);
    boolean logoutUser(User user);
    User findByUserName(String userName);
    User updateUser(User user);
    boolean updateUserPoints(String userName, int delta);
    int getTotalPoints(String userName);
    void deleteUser(String userName);
    List<User> findAllUsers();
    Comment createComment(Comment comment);
    boolean deleteComment(Comment comment);
    boolean editComment(Comment updatedComment);
    boolean addFavorite(LearningMaterial material, User user);
    boolean removeFavorite(LearningMaterial material, User user);
    Favorite showFavorites(User user);
    boolean addUserToGroup(User user, Group group);
    boolean removeUserFromGroup(User user, Group group);

}
